routes/web.php
<?php

use App\Http\Controllers\ActivityController;
use App\Http\Controllers\BrandController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\FileController;
use App\Http\Controllers\WebsiteController;
use App\Http\Controllers\ImageController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ProjectController;
use App\Http\Controllers\SentenceController;
use App\Http\Controllers\SubActivityController;
use App\Http\Controllers\TicketController;
use App\Http\Controllers\UserController;
use App\Models\Brand;
use App\Models\Image;
use App\Models\Product;
use App\Models\SubActivity;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return redirect('/home');
    $ar = [
        'Hello' => 'HelloX',
        'Yes' => 'YesX'
    ];
    unset($ar['Hello']);
    dd($ar);
    //send email for user contain link of new passord
    Mail::send('mail_test', array('body' => 'Test Email'),
    function ($message) {
        $message->to('eng.yousha.asaad@gmail.com');
        $message->subject('Test');
    });


     //get base sentences (in english) from languages file to transalte it
     $source = require resource_path('lang/ar/sentence.php');
     //we store translations here

     //fill temp array with all english sentences and make its translations = ' '
     foreach ($source as $key => $value) {
         $temp[$key] = '';
     }

    /*
    $prodcuts = Brand::find(1);
    dd($prodcuts->images[0]->path);
    */
    /*
    $image = new Image();
    $image->path = 'assets/images/brancd/wavetec2.png';

    $prodcuts = Brand::find(1);
    $prodcuts->images()->save($image);
    dd($prodcuts);
    */
    return view('welcome');
});

//website toutes
Route::get('/home', [WebsiteController::class , 'index']);
Route::get('/services', [WebsiteController::class , 'showServices'])->name('showService');

//panel routes
Route::resource('brand' , BrandController::class);
Route::resource('category' , CategoryController::class);
Route::resource('product' , ProductController::class);
Route::resource('image' , ImageController::class);
Route::resource('project' , ProjectController::class);
Route::resource('activity' , ActivityController::class);
Route::resource('sub-activity' , SubActivityController::class);
Route::resource('ticket' , TicketController::class);
Route::resource('file' , FileController::class);
Route::resource('user' , UserController::class);
Route::resource('client' , ClientController::class);
Route::resource('sentence' , SentenceController::class);

Route::post('/delete_brands', [BrandController::class , 'deleteGroup'])->name('delete_brands');
Route::post('/delete_clients', [ClientController::class , 'deleteGroup'])->name('delete_clients');
Route::post('/delete_categories', [CategoryController::class , 'deleteGroup'])->name('delete_categories');
Route::post('/delete_products', [ProductController::class , 'deleteGroup'])->name('delete_products');
Route::get('{brand_id}/categories' , [BrandController::class , 'showCategories'])->name('showCategories');
Route::post('/delete_activities', [ActivityController::class , 'deleteGroup'])->name('delete_activities');
Route::post('/delete_sub_activities', [SubActivityController::class , 'deleteGroup'])->name('delete_sub_activities');
Route::post('/delete_files', [FileController::class , 'deleteGroup'])->name('delete_files');
Route::get('/downloads/{type}', [FileController::class , 'show_downloads'])->name('downloads');
Route::post('/verify_all_users', [UserController::class , 'verifyGroup'])->name('verify_all_users');

Route::post('/resolve_tickets', [TicketController::class , 'resolve_all_tickets'])->name('resolve_tickets');

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');


//General setting

Route::get('/general', [App\Http\Controllers\GeneralSetting::class, 'index'])->name('general_setting');
Route::get('/updated_ticekts_time', [App\Http\Controllers\GeneralSetting::class, 'update_times'])->name('update_times');
Route::get('/change_language', [App\Http\Controllers\GeneralSetting::class, 'change_language'])->name('change_language');

app/Models/Brand.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;

class Brand extends Model implements Operations
{
    use HasFactory;

    public $fillable = ['brand_name' , 'description'];
    public $timestamps = false;

    //relations

    public function categories(){
        return $this->hasMany(Category::class);
    }

    public function images(){
        return $this->morphMany(Image::class , 'imageable');
    }

    //operation
    public static function getAll(){
        return Brand::all();
    }

    public static function  getById($id){
        return Brand::find($id);
    }

    public static function getByColumn($column , $value){
        return DB::table('brands')->where($column , $value)->get();
    }

    public static function insert_data($data){
        return DB::table('brands')->insert($data);
    }

    public static function update_data($id , $data){
       return  DB::table('brands')->where('id' , $id)->update($data);
    }
    public static function delete_data($id){
        return DB::table('brands')->where('id' , $id)->delete();
    }

}

app/Http/Controllers/BrandController.php
<?php

namespace App\Http\Controllers;

use App\Models\Brand;
use App\Models\Category;
use App\Models\Image;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\App;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\Validator;

class BrandController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        App::setLocale(Session::get('lang'));
       return view('pages.brand.index')->withBrands(Brand::getAll());
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all() , [
            'brand_name' => 'required|max:40',
            'description' => 'required',
            'images' => 'required'
        ]);

        if($validator->fails())
        {
           Session::flash('fail' , "Try Again");
           return redirect()->back();
        }else
        {
           DB::beginTransaction();

           try{
               $new_brand = Brand::create([
                'brand_name' => $request->brand_name,
                'description' => $request->description,
               ]);

               if($new_brand != null)
               {
                   //add images for this brand
                   foreach($request->file('images') as $image)
                   {
                       $random_image_name = uniqid().'.'.$image->clientExtension();
                       $image->move(public_path('assets/images/brand'), $random_image_name);

                       //add image for Images table
                       $image_data = new Image();
                       $image_data->path = env('APP_URL').'/assets/images/brand/'.$random_image_name;

                       $new_brand->images()->save($image_data);
                   }

                   //add brand data to translation file
                   storeSetneceInLanguageFile([$request->brand_name , $request->description]);
                   DB::commit();
                   Session::flash('success' , 'Done Successfully');
               }
           }catch(\Exception $ex)
           {
               DB::rollBack();
               Log::info('Error in add brand');
               Log::info($ex->getMessage());
           }

           return redirect()->back();
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Brand  $brand
     * @return \Illuminate\Http\Response
     */
    public function show(Brand $brand)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Brand  $brand
     * @return \Illuminate\Http\Response
     */
    public function edit(Brand $brand)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Brand  $brand
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Brand $brand)
    {
        $validator = Validator::make($request->all() , [
            'brand_name' => 'required|max:40',
            'description' => 'required',
        ]);

        if($validator->fails())
        {
           Session::flash('fail' , "Try Again");
           return redirect()->back();
        }else
        {
           DB::beginTransaction();

           try{

               //chnage sentecnes in language file
               replaceSetneceInLanguageFile([
                   $brand->brand_name => $request->brand_name,
                   $brand->description => $request->description,
               ]);

               //changeable
               $updated_brand = Brand::update_data($brand->id ,[
                'brand_name' => $request->brand_name,
                'description' => $request->description,
               ]);
                   //add images for this brand
                   //here user might not add any extra image
                   if($request->file('images') != null )
                   {

                        foreach($request->file('images') as $image)
                        {
                            $random_image_name = uniqid().'.'.$image->clientExtension();
                            $image->move(public_path('assets/images/brand'), $random_image_name);

                            //add image for Images table
                            $image_data = new Image();
                            $image_data->path = env('APP_URL').'/assets/images/brand/'.$random_image_name;

                            $brand->images()->save($image_data);
                        }
                   }


               DB::commit();
               Session::flash('success' , 'Done Successfully');
           }catch(\Exception $ex)
           {
               dd($ex->getMessage());
               DB::rollBack();
               Log::info('Error in update brand');
               Log::info($ex->getMessage());
           }

           return redirect()->back();
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Brand  $brand
     * @return \Illuminate\Http\Response
     */
    public function destroy(Brand $brand)
    {
        DB::beginTransaction();
        try{
            $data = [$brand->brand_name , $brand->description];

           //here we will delete brand with its images

           //delete images
           foreach($brand->images as $image)
           {
               //get image name with extension then delete it from public folder
               $image_name = substr($image->path , strrpos($image->path , '/') +1);
               File::delete(public_path('assets/images/brand/'.$image_name));
               $image->delete();
           }

           $brand->delete();
           deleteSetneceInLanguageFile($data);
           DB::commit();
           Session::flash('success' , 'Done Successfully');


        }catch(\Exception $ex)
        {
            Session::flash('fail' , "Try Again");
            DB::rollBack();
            Log::info($ex->getMessage());
        }

        return redirect()->back();
    }

    public function deleteGroup(Request $request)
    {
        DB::beginTransaction();
        try{
            unset($request['_token']);
            $deleted_brands_ids = array_values($request->all());
            foreach($deleted_brands_ids as $id)
            {
                //here we will delete brand with its images
                $brand = Brand::getById($id);


                //delete images
                foreach($brand->images as $image)
                {
                    //get image name with extension then delete it from public folder
                    $image_name = substr($image->path , strrpos($image->path , '/') +1);
                    File::delete(public_path('assets/images/brand/'.$image_name));
                    $image->delete();
                }

                $brand->delete();

            }

            DB::commit();
            Session::flash('success' , 'Done Successfully');


        }catch(\Exception $ex)
        {
            Session::flash('fail' , "Try Again");
            DB::rollBack();
            Log::info($ex->getMessage());
        }

        return redirect()->back();
    }

    public function showCategories($brand_id)
    {
        App::setlocale(Session::get('lang'));
        $categories = Category::getCategoriesForBrand($brand_id);
        $brand_name = Brand::getById($brand_id)->brand_name;

        return view('pages.brand_categories')->with(compact('categories' , 'brand_name'));
    }
}

resources/views/modals/brand/addBrand.blade.php
<div id="addBrandModal" class="modal fade">
	<div class="modal-dialog">
		<div class="modal-content">
			<form method="POST"  action="{{route('brand.store')}}"  enctype="multipart/form-data">
                @csrf
				<div class="modal-header">
					<h4 class="modal-title">Add Brand</h4>
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
				</div>
				<div class="modal-body">
					<div class="form-group">
						<label for="addBrandName">Brand Name</label>
						<input id="addBrandName" type="text" class="form-control" name="brand_name" maxlength="40" required>
					</div>

                     <div class="form-group">
                        <label for="addimge" class="form-label">Brand image</label>
                        <input class="form-control form-control-md" name="images[]" multiple id="addimge" type="file" accept="image/*" required>
                      </div>

					<div class="form-group">
						<label for="brandDescription">Brand Description</label>
						<textarea id="brandDescription" class="form-control" name="description" required required></textarea>
					</div>
				</div>
				<div class="modal-footer">
					<input type="button" class="btn btn-info" data-dismiss="modal" value="Cancel">
					<input type="submit" class="btn btn-success" value="Add">
				</div>
			</form>
		</div>
	</div>
</div>

resources/views/modals/brand/deleteBrand.blade.php
<div id="deleteEmployeeModal" class="modal fade">
	<div class="modal-dialog">
		<div class="modal-content">
			<form>
				<div class="modal-header">
					<h4 class="modal-title">Delete Employee</h4>
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
				</div>
				<div class="modal-body">
					<p>Are you sure you want to delete these Records?</p>
					<p class="text-warning"><small>This action cannot be undone.</small></p>
				</div>
				<div class="modal-footer">
					<input type="button" class="btn btn-default" data-dismiss="modal" value="Cancel">
					<input type="submit" class="btn btn-danger" value="Delete">
				</div>
			</form>
		</div>
	</div>
</div>

resources/views/modals/brand/editBrand.blade.php
<div id="editBrandModal" class="modal fade">
	<div class="modal-dialog">
		<div class="modal-content">
			<form method="post" enctype="multipart/form-data">
                @csrf
                @method('put')
				<div class="modal-header">
					<h4 class="modal-title">Edit Brand</h4>
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
				</div>
				<div class="modal-body">
                    <div class="form-group">
						<label for="editBrandName">Brand Name</label>
						<input id="editBrandName" type="text" class="form-control" name="brand_name" maxlength="40" required>
					</div>

                     <div class="form-group">
                        <label for="editimge" class="form-label">Brand image</label>
                        <input class="form-control form-control-md" name="images[]" multiple id="editimge" type="file" accept="image/*">
                      </div>

					<div class="form-group">
						<label for="editBrandDescription">Brand Description</label>
						<textarea id="editBrandDescription" class="form-control" name="description" required required></textarea>
					</div>
				</div>
				<div class="modal-footer">
					<input type="button" class="btn btn-default" data-dismiss="modal" value="Cancel">
					<input type="submit" class="btn btn-info" value="Save">
				</div>
			</form>
		</div>
	</div>
</div>